import { Gene, IChromosome } from '..';
export declare abstract class ChromosomeBase implements IChromosome {
    private readonly _length;
    private readonly genes;
    fitness: undefined;
    protected constructor(_length: number);
    get length(): number;
    getGene(index: number): Gene;
    setGene(index: number, gene: Gene): void;
    abstract generateGene(index: number): Gene;
    abstract createNew(): ChromosomeBase;
    clone(): ChromosomeBase;
    copyFrom(from: ChromosomeBase): void;
    mutation(index: number): void;
}
