"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class PopulationBase {
    constructor(_size, _adamChromosome, _bestChanged = undefined) {
        this._size = _size;
        this._adamChromosome = _adamChromosome;
        this._bestChanged = _bestChanged;
        this._chromosomes = [];
        this._generation = 0;
        this._fitness = 0;
    }
    get chromosomes() {
        return this._chromosomes;
    }
    get best() {
        return this._chromosomes[0];
    }
    get fitness() {
        return this._fitness;
    }
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            this._chromosomes = new Array(this._size);
            this._generation = 0;
            yield Promise.all([...Array(this._size)].map(() => this._chromosomes.push(this._adamChromosome.createNew())));
        });
    }
    update(chromosomes) {
        return __awaiter(this, void 0, void 0, function* () {
            // eslint-disable-next-line no-magic-numbers
            this._chromosomes = Array.from(chromosomes).sort((chromosome1, chromosome2) => { var _a, _b; return ((_a = chromosome2.fitness) !== null && _a !== void 0 ? _a : -1.0) - ((_b = chromosome1.fitness) !== null && _b !== void 0 ? _b : -1.0); });
            if (this.best.fitness !== undefined && this.best.fitness !== this._fitness) {
                this._fitness = this.best.fitness;
                if (this._bestChanged) {
                    yield this._bestChanged();
                }
            }
        });
    }
}
exports.PopulationBase = PopulationBase;
//# sourceMappingURL=PopulationBase.js.map